#! /usr/bin/env node

const loadingSpinner = require('loading-spinner');
const shell = require('shelljs');
const replace = require('replace');
const fs = require('fs')
const path = require('path');
const ncp = require('ncp').ncp;
ncp.limit = 16;

const projectName = process.argv[2];

const dir = './' + projectName;
if (!fs.existsSync(dir)) {
    fs.mkdirSync(dir);
} else {
    return console.error('Directory Alredy Exist!');
}

const srcPath = path.join(path.resolve(__dirname), 'node_modules', 'create-jqwidgets-react-tsx-app');;
const destPath = path.join(process.cwd(), projectName);

ncp(srcPath, destPath, function (err) {
    if (err) {
        return console.error(err);
    }
    replace({
        regex: 'create-jqwidgets-react-tsx-app',
        replacement: projectName,
        paths: [
            path.join(destPath, 'package.json')
        ],
        recursive: true,
        silent: true
    });


    console.log('\x1b[36m%s\x1b[0m', 'Project ' + projectName + ' Created!');
    console.log('\x1b[36m%s\x1b[0m', 'Installing npm Packages...\n');
    loadingSpinner.start(100, {
        clearChar: true
    });
    process.chdir(destPath);
    shell.exec('npm install', function () {
        loadingSpinner.stop();
    });
});
